package com.mortals.xhx.module.demo.print;

import com.mortals.xhx.common.utils.QrCodeUtil;

import java.awt.*;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;

import javax.swing.*;

public class Main extends JFrame {
    public Main() {
        setTitle("绘制几何图形");
        setBounds(100, 200, 500, 500);
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        setVisible(true);

        Container c = getContentPane();
        MyCanvas canvas = new MyCanvas();
        c.add(canvas);
    }

    private class MyCanvas extends Canvas {
        @Override
        public void paint(Graphics g) {
            Graphics2D g2 = (Graphics2D) g;//新绘图类

            //Image img = new ImageIcon("src/a.png").getImage();//获取图片来源
            //g2.drawImage(img, 50, 0, this);a


            BufferedImage barCode = QrCodeUtil.getBarCode("1231313123123131312aaaaaaaaaaa");
            //g2.drawImage(barCode,null,20,100);
            //居右
            FontMetrics fontMetrics = g2.getFontMetrics();
            String str="1231313123123131312aaaaaaaaaaa";
            g2.drawImage(barCode,null,480 - barCode.getWidth(),100);

            Color c = Color.RED;//设置颜色属性
            Stroke stroke = new BasicStroke(8);//设置画笔属性
            Font font = new Font("隶书", Font.BOLD, 16);
            g2.setFont(font);//加载字体
            g2.drawString("#################################################################################", 0, 30);//
            g2.drawString("==================================================================", 0, 50);//
            g2.drawString("..................................................................", 0, 70);//
            //居右
             fontMetrics = g2.getFontMetrics();
             str="a lot of apple";
            g2.drawString(str, 480 - fontMetrics.stringWidth(str), 90);//

            //居中
            fontMetrics = g2.getFontMetrics();
            String str1="two lot of apple";
            g2.drawString(str, (480 - fontMetrics.stringWidth(str1))/2, 220);//



            float[]   dash1   =   {2.0f};

//设置打印线的属性。

//1.线宽 2、3、不知道，4、空白的宽度，5、虚线的宽度，6、偏移量

            //g2.setStroke(new   BasicStroke(0.5f,   BasicStroke.CAP_BUTT,   BasicStroke.JOIN_MITER,   2.0f,   dash1,   0.0f));

            g2.drawLine(10,10,200,10);

//			g2.setStroke(stroke);//加载画笔

            /*BasicStroke.CAP_ROUND : 圆角末端
             *BasicStroke.CAP_BUTT :无修饰末端
             *BasicStroke.CAP_SQUARE :正方形末端
             *
             *BasicStroke.JOIN_BEVEL :平角
             *BasicStroke.JOIN_MITER :尖角（默认）
             *BasicStroke.JOIN_ROUND :圆角
             * */
            stroke = new BasicStroke(12, BasicStroke.CAP_SQUARE, BasicStroke.JOIN_ROUND);
            g2.setStroke(stroke);//加载画笔


//			g2.setColor(c);
//            g2.setColor(Color.BLUE);
//            g2.drawOval(60, 20, 30, 30);// 画了一个圆
//            g2.setColor(c);
//            g2.fillRect(60, 20, 20, 20);// 画矩形
//            g2.setColor(Color.BLUE);
//
//            Shape shape1 = new Rectangle2D.Double(110, 5, 100, 100);// 矩形圆形对象
//            g2.fill(shape1);// 画这个图形
//
//            Shape shape2 = new Rectangle2D.Double(220, 15, 80, 80);// 矩形圆形对象
//            g2.fill(shape2);// 画这个图形
//
//            g2.drawArc(320, 25, 100, 50, 270, 200);// 弧形
//
//            g2.drawLine(5, 120, 100, 120);//横线
//            g2.drawLine(50, 120, 50, 200);//垂直线
//
//            g2.drawRoundRect(120, 120, 100, 50, 10, 10);// 圆角矩形
//
//            int x[] = { 250, 300, 250, 300 };
//            int y[] = { 130, 130, 200, 200 };
////			g2.drawPolygon(x, y, 4);// 多边形
//
//            g2.drawPolyline(x, y, 4);// 多边线


        }
    }

    /**
     * Graphic2D文本绘制换行，多行绘制
     *
     * @param graphics2D  Graphics2D画笔实例
     * @param text        需要绘制的文本内容
     * @param maxWidth    一行的总宽度（像素）
     * @param startX      X坐标起始点（像素）
     * @param startY      Y坐标起始点（像素）
     * @param heightSpace 每行间距（像素）
     */
    public static void drawStringWithMultiLine(Graphics2D graphics2D, String text, int maxWidth, int startX, int startY, int heightSpace) {
        // INFO: Dechert: 2021/1/7 获取画笔的字体
        Font font = graphics2D.getFont();
        // INFO: Dechert: 2021/1/7 通过JLabel获取文本的总长度和总高度
        JLabel jLabel = new JLabel(text);
        jLabel.setFont(font);
        FontMetrics fontMetrics = jLabel.getFontMetrics(font);
        int textLength = text.length();
        int totalWidth = fontMetrics.stringWidth(text); //一行的总长度，用于判断是否超出了范围
        int textHeight = fontMetrics.getHeight(); //计算一行的高度

        if (totalWidth > maxWidth) {
            // INFO: Dechert: 2021/1/7 总长度超过了整个长度限制
            int alreadyWriteLine = 0; //已经写了多少行
            int nowWidth = 0; //目前一行写的长度
            for (int i = 0; i < textLength; i++) {
                int oneWordWidth = fontMetrics.charWidth(text.charAt(i)); //获取单个字符的长度
                int tempWidth = oneWordWidth + nowWidth; //判断目前的一行加上这个字符的长度是否超出了总长度
                if (tempWidth > maxWidth) {
                    // INFO: Dechert: 2021/1/7 如果超出了一行的总长度，则要换成下一行
                    nowWidth = 0;
                    alreadyWriteLine++;
                    int writeY = startY + alreadyWriteLine * (textHeight + heightSpace);
                    graphics2D.drawString(text.charAt(i) + "", startX + nowWidth, writeY);
                    nowWidth = oneWordWidth;
                } else {
                    // INFO: Dechert: 2021/1/7 当前行长度足够，可以直接画
                    int writeY = startY + alreadyWriteLine * (textHeight + heightSpace);
                    graphics2D.drawString(text.charAt(i) + "", startX + nowWidth, writeY);
                    nowWidth = tempWidth;
                }
            }
        } else {
            // INFO: Dechert: 2021/1/7 没有超过限制，直接画
            graphics2D.drawString(text, startX, startY);
        }
    }

    public static void main(String args[]) {
        Main m = new Main();

    }
}